// JavaScript Documentvar
  var myBookMarkJs = {
	  setStartChecked :function(){
		var myButton = document.getElementById('myTabBookmarks-Menu');
		myButton.setAttribute('open', 'true');
	  },
	  
	  onPanelClose :function(){
		var myButton = document.getElementById('myTabBookmarks-Menu');
		myButton.setAttribute('open', 'false');	
		document.getElementById('main-window').focus();
	  },		  
	  
	  SetPanelHeight: function(){
		var boxHeight=document.getElementById('appcontent').boxObject.height * 0.85 ;
		var myBox=document.getElementById('myPanelBox');
		myBox.setAttribute('height', boxHeight);	
	  },
	  
	  OpenBookMark : function(){
		var myBookMarksTabs=document.getElementById('myBookMarksTabs');
		var myPanel=document.getElementById('myPanel');			
		if(myBookMarksTabs.selectedIndex==-1) myBookMarksTabs.selectedIndex=0 ;
		if(myPanel.getAttribute('firstOpen')=='true'){			
			myBookMarksTabs.selectedIndex=0 ;
			myPanel.setAttribute('firstOpen', 'false');
		}
		if(myBookMarksTabs.selectedIndex==0) myBookMarkJs.BookMarkFillData() ;
		else if(myBookMarksTabs.selectedIndex==1) myBookMarkJs.HistoryFillData() ;
	  },
	  
	  BookMarkFillData : function(){
		var tree = document.getElementById('myBookmarks-view');		
		tree.place ='place:queryType=1&folder=' + window.top.PlacesUIUtils.allBookmarksFolderId;
		
		var mySearchbox = document.getElementById('myBookmarkSearch-box');	
		var aSearchString=mySearchbox.value	;
		
		if (!aSearchString)
			tree.place = tree.place;
		else
		tree.applyFilter(aSearchString,
			[PlacesUtils.bookmarksMenuFolderId,
			PlacesUtils.unfiledBookmarksFolderId,
			PlacesUtils.toolbarFolderId]); 		  
	  },
	  
	  BookMarkSearch : function(aInput){
		var aSearchString=aInput.value ;        
		var tree = document.getElementById('myBookmarks-view');
		if (!aSearchString)
		tree.place = tree.place;
		else
		tree.applyFilter(aSearchString,
			[PlacesUtils.bookmarksMenuFolderId,
			PlacesUtils.unfiledBookmarksFolderId,
			PlacesUtils.toolbarFolderId]); 		  
	 }, 
	  
	  HistoryFillData : function(){
	  
		var gmyHistoryTree;
		var gSearchBox;
		var gHistoryGrouping = '';
		var gSearching = false;
		
		function HistorySidebarInit()
		{
			gHistoryTree = document.getElementById('myHistoryTree');
			gHistoryGrouping = document.getElementById('viewButton').
									  getAttribute('selectedsort1');
			
			if (gHistoryGrouping == 'site')
				document.getElementById('bysite').setAttribute('checked', 'true');
			else if (gHistoryGrouping == 'visited') 
				document.getElementById('byvisited').setAttribute('checked', 'true');
			else if (gHistoryGrouping == 'lastvisited')
				document.getElementById('bylastvisited').setAttribute('checked', 'true');
			else if (gHistoryGrouping == 'dayandsite')
				document.getElementById('bydayandsite').setAttribute('checked', 'true');
			else
				document.getElementById('byday').setAttribute('checked', 'true');			

			gSearchBox = document.getElementById('search-box');
		  searchHistory(gSearchBox.value);				
		}
		
		function searchHistory(aInput)
		{
		  var query = PlacesUtils.history.getNewQuery();
		  var options = PlacesUtils.history.getNewQueryOptions();
		
		  const NHQO = Ci.nsINavHistoryQueryOptions;
		  var sortingMode;
		  var resultType;
		
		  if (aInput) {
			query.searchTerms = aInput;
			sortingMode = NHQO.SORT_BY_TITLE_ASCENDING;
			resultType = NHQO.RESULTS_AS_URI;
		  }
		  else {
			switch (gHistoryGrouping) {
			  case 'visited':
				resultType = NHQO.RESULTS_AS_URI;
				sortingMode = NHQO.SORT_BY_VISITCOUNT_DESCENDING;
				break; 
			  case 'lastvisited':
				resultType = NHQO.RESULTS_AS_URI;
				sortingMode = NHQO.SORT_BY_DATE_DESCENDING;
				break; 
			  case 'dayandsite':
				resultType = NHQO.RESULTS_AS_DATE_SITE_QUERY;
				break;
			  case 'site':
				resultType = NHQO.RESULTS_AS_SITE_QUERY;
				sortingMode = NHQO.SORT_BY_TITLE_ASCENDING;
				break;
			  case 'day':
			  default:
				resultType = NHQO.RESULTS_AS_DATE_QUERY;
				break;
			}
		  }
		  options.sortingMode = sortingMode;
		  options.resultType = resultType;
		  gHistoryTree.load([query], options);
		}
		HistorySidebarInit();
	},
	
	 SU_handleTreeClick : function(aTree, aEvent, aGutterSelect) {
		if (aEvent.button == 2)
		  return;
		var tbo = aTree.treeBoxObject;
		var row = { }, col = { }, obj = { };
		tbo.getCellAt(aEvent.clientX, aEvent.clientY, row, col, obj);
		if (row.value == -1 || obj.value == 'twisty')
		  return;
		var mouseInGutter = false;
		if (aGutterSelect) {
		  var x = { }, y = { }, w = { }, h = { };
		  tbo.getCoordsForCellItem(row.value, col.value, 'image', x, y, w, h);
		  mouseInGutter = aEvent.clientX < x.value;
		}
		var modifKey = aEvent.ctrlKey || aEvent.shiftKey;
		var isContainer = tbo.view.isContainer(row.value);
		var openInTabs = isContainer &&
			 (aEvent.button == 1 ||
			  (aEvent.button == 0 && modifKey)) &&
			 PlacesUtils.hasChildURIs(tbo.view.nodeForTreeIndex(row.value));
		if (aEvent.button == 0 && isContainer && !openInTabs) {
		  tbo.view.toggleOpenState(row.value);
		  return;
		}
		else if (!mouseInGutter && openInTabs &&
				aEvent.originalTarget.localName == 'treechildren') {
		  tbo.view.selection.select(row.value);
		  PlacesUIUtils.openContainerNodeInTabs(aTree.selectedNode, aEvent);
		}
		else if (!mouseInGutter && !isContainer &&
				 aEvent.originalTarget.localName == 'treechildren') {
		  tbo.view.selection.select(row.value);
		  PlacesUIUtils.openNodeWithEvent(aTree.selectedNode, aEvent);
			if(aEvent.button == 0){
				if (aTree.selectedNode && PlacesUtils.nodeIsURI(aTree.selectedNode) ) {
					document.getElementById('myPanel').hidePopup() ;
				}
			}
		}
	} ,

	searchHistory :function searchHistory(aInput)
	{
	  var query = PlacesUtils.history.getNewQuery();
	  var options = PlacesUtils.history.getNewQueryOptions();
	  const NHQO = Ci.nsINavHistoryQueryOptions;
	  var sortingMode;
	  var resultType;
	  if (aInput) {
		query.searchTerms = aInput;
		sortingMode = NHQO.SORT_BY_TITLE_ASCENDING;
		resultType = NHQO.RESULTS_AS_URI;
	  }
	  else {
		gSearchBox = document.getElementById('search-box');
		gSearchBox.value='' ;
		gHistoryGrouping = document.getElementById('viewButton').getAttribute('selectedsort1');
		switch (gHistoryGrouping) {
		  case 'visited':
			resultType = NHQO.RESULTS_AS_URI;
			sortingMode = NHQO.SORT_BY_VISITCOUNT_DESCENDING;
			break; 
		  case 'lastvisited':
			resultType = NHQO.RESULTS_AS_URI;
			sortingMode = NHQO.SORT_BY_DATE_DESCENDING;
			break; 
		  case 'dayandsite':
			resultType = NHQO.RESULTS_AS_DATE_SITE_QUERY;
			break;
		  case 'site':
			resultType = NHQO.RESULTS_AS_SITE_QUERY;
			sortingMode = NHQO.SORT_BY_TITLE_ASCENDING;
			break;
		  case 'day':
		  default:
			resultType = NHQO.RESULTS_AS_DATE_QUERY;
			break;
			}
		}
		options.sortingMode = sortingMode;
		options.resultType = resultType;
		var gHistoryTree = document.getElementById('myHistoryTree');
		gHistoryTree.load([query], options);
	},
	
/* µǿ¼ӱǩҳ */	
/*---------------------------------------------------------------------------------*/	
	mySelectTab :document.getElementById('mySelectTab') ,
	nativeJSON : Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON),
	currentList : [] ,
	firstOpen : true ,
	/* õmainBroadcasterSetеsidebarurllabel ,бŵcurrentList */
    getList : function(){
		var myList=null;
		//tabб { 'id':'' , 'title':''  , 'url':'' , 'used':'' ,"cmd" :"" }
		var currentList= myBookMarkJs.currentList  ;
		if(currentList.length != 0) {
			myList=currentList;
		}
		else{
			var myTabSet =[];		
			var mainBcs = document.getElementById('mainBroadcasterSet') ;
			var strMenuList=""
			for (var i=0 ;i < mainBcs.childNodes.length;i++){
				var n= mainBcs.childNodes[i] ;
				var tabUrl = mainBcs.childNodes[i].getAttribute('sidebarurl') ;
				
				if(strMenuList.indexOf(tabUrl) == -1 && n.hasAttribute('sidebarurl') && n.hasAttribute('label') &&  n.getAttribute('id')!="viewBookmarksSidebar"){
					var tabId = mainBcs.childNodes[i].getAttribute('id') ;
					var tabLabel = mainBcs.childNodes[i].getAttribute('label') ;
					var cmd =  mainBcs.childNodes[i].getAttribute('oncommand') ;
					var tab={
						'id': tabId , 
						'title': tabLabel ,
						'url': tabUrl ,
						'used': false ,
						'cmd' : cmd
					}
					myTabSet.push(tab); 
					strMenuList +="|" + tabUrl ;
				}
			}
			myBookMarkJs.currentList= myTabSet ; 
			myList =myTabSet;
		}
		return myList ;
	}	,
	
	/*ԸĹرհť¼ */
	setSidebarCloseCmd : function(strCmd){
		var myCmd = " myBookMarkJs.onPanelClose() ; "
		myCmd += strCmd ;	
		var mySidebarClose = document.getElementById('mySidebarClose') ;
		mySidebarClose.setAttribute("oncommand", myCmd );
	},

	/*ڵһδʱ,ͨmySelectTabťȡselectedTabsֵ,жϵǰѡеб. */	
	getDefaultTab : function(){
		if (!myBookMarkJs.firstOpen) return ;
		var selectedTabs = myBookMarkJs.mySelectTab.getAttribute("selectedTabs") ;
		var myList=this.getList() ;
		if (myList.length > 0 ){
			myBookMarkJs.mySelectTab.setAttribute("hidden","false") ;
			for (var i=0 ;i<myList.length ;i++){
				var list=myList[i] ;		
				if (selectedTabs.indexOf(list.id) > 0){
					myBookMarkJs.currentList[i].used=true ;
					myBookMarkJs.AddTab(list ,i) ;
				}
			}
		}
		myBookMarkJs.addSidebarLoad() ;
		myBookMarkJs.setSidebarCloseCmd("toggleSidebar('viewBookmarksSidebar');");		
		myBookMarkJs.firstOpen=false ;
	},
	
	addSidebarLoad : function(){
		var mySidebar = document.getElementById("mySidebar");	
		function setSideBarFocus(){
			var sc=mySidebar.contentDocument ;
			var myPage  = sc.getElementsByTagName( "page");
			if(myPage && myPage.length >0 ) myPage[0].focus(); 
			else{
				var myWin=sc.getElementsByTagName( "window");
				if(myWin && myWin.length >0 ) myWin[0].focus(); 
			}			
		}
		mySidebar.addEventListener("load", function(){setSideBarFocus()}, true);		
	},
	
	/*mySelectTabťPopupֵ */
	cteateTabPopMenu : function(){
		var tabPopup =document.getElementById("selectTabPop");	
		while(tabPopup.firstChild) tabPopup.removeChild(tabPopup.firstChild);
		var myList=myBookMarkJs.currentList ;
		for (var i=0 ;i<myList.length ;i++){
			var list=myList[i] ;
			var m = document.createElement('menuitem');
			m.setAttribute('id',  "tabList" + i);				
			m.setAttribute('tabId', list.id);				  
			m.setAttribute('label', list.title );
			m.setAttribute('type', 'checkbox');
			m.setAttribute('value', i);	
			m.setAttribute('checked', list.used);				
			m.setAttribute('oncommand',"myBookMarkJs.menuChaged(this , '"+list.title + "','" +list.url +"');");
			tabPopup.appendChild(m) ;			
		}
	},

	/*ѡ˲˵󴥷,ӻtabҳ */
	menuChaged : function (menuItem ,title ,url) {
		var myBookMarksTabs=document.getElementById('myBookMarksTabs');
		var n=menuItem.getAttribute('value') ;
		myBookMarkJs.currentList[n].used =!myBookMarkJs.currentList[n].used ;
		if(myBookMarkJs.currentList[n].used) {
			myBookMarkJs.AddTab(myBookMarkJs.currentList[n] , n ) ;
			myBookMarkJs.myToggleSidebar(url) ;
		}
		else {
			myBookMarksTabs.selectedIndex=0 ;			
			myBookMarksTabs.removeChild(document.getElementById("myTab" + n));
		}
		myBookMarkJs.setStartChecked() ;
		var strSelectTab="" ;
		for (var i=0 ;i<myBookMarkJs.currentList.length; i ++ ){
			if(myBookMarkJs.currentList[i].used) {
				strSelectTab +="|" + myBookMarkJs.currentList[i].id  ;
			}
		}
		myBookMarkJs.mySelectTab.setAttribute("selectedTabs",strSelectTab);
	},
	
	/*myBookMarksTabstab,öӦĹرpanel */
	AddTab :function(list ,no ){
		myTabs= document.getElementById("myBookMarksTabs");
		var tab = document.createElement('tab')
		image="chrome://scrapbook/skin/main.png" ;
		tab.setAttribute('id', "myTab" + no );		
		tab.setAttribute('label', list.title);
		tab.setAttribute('cmd', list.cmd);	
		tab.setAttribute('image', image);	
		tab.setAttribute('linkedpanel', "ccc");			
		tab.setAttribute("oncommand", "myBookMarkJs.setSidebarCloseCmd(this.getAttribute('cmd')) ;"
			+ "myBookMarkJs.setStartChecked() ;"																						 			+ "myBookMarkJs.myToggleSidebar('"  +  list.url +  "'); ");
		tab.className="myTab" ;
		myTabs.appendChild(tab);
	},
	
	/*tabʾӦ */	
	myToggleSidebar : function ( myUrl ) {
		var mySidebar = document.getElementById("mySidebar");
		var url = myUrl;
		mySidebar.removeAttribute("src") ;
		mySidebar.setAttribute("src", url	); 
	},
	
	/*ô򿪲ĶӦ¼ */
	setSecurityButton :function() {	
		var sidebarBox=document.getElementById('sidebar-box') ;		
		function setData(){
			if(!sidebarBox.hasAttribute("hidden")) document.getElementById('myPanel').hidePopup() ;
		}
		sidebarBox.addEventListener('DOMAttrModified',function(e){
			setData();
		},false);	
	}	
	
 }

myBookMarkJs.setSecurityButton() ;